#-------------------------------------------------
#
# Project created by QtCreator 2011-01-17T12:02:16 
#
#-------------------------------------------------

QT       += core gui
QT       += opengl

CONFIG += app
CONFIG += console
TARGET = QtSampler
TEMPLATE = app

CONFIG  += qxt
QXT     += core gui

win32:DEFINES += _CRT_SECURE_NO_WARNINGS
#DEFINES += _USE_OPEN_CV
DEFINES += _ITF_LIB_QT

win32 {
    CONFIG(debug, release|debug):DESTDIR = ../QtProjects/debug/
    CONFIG(release, release|debug):DESTDIR = ../QtProjects/release/
}

SOURCES += \
    sampler_dock.cpp \
    sampler_window_version.cpp \
    sampler_window_ut.cpp \
    sampler_window_tex.cpp \
    sampler_window_dft.cpp \
    sampler_window_data.cpp \
    sampler_window_action.cpp \
    sampler_window.cpp \
    sampler_pane_ut.cpp \
    sampler_pane_gl.cpp \
    sampler_pane.cpp \
    sampler_monitor.cpp \
    sampler_main.cpp \
    sampler_dock.cpp \
    sampler_common.cpp \
    props_op_dft_filter.cpp \
    image_splitter.cpp \
    image_side_splitter.cpp \
    image_side_label.cpp \
    image_ctrl.cpp

HEADERS += \
    sampler_dock.h \
    sampler_window.h \
    sampler_panes.h \
    sampler_pane.h \
    sampler_monitor.h \
    sampler_dock.h \
    sampler_common.h \
    props_op_dft_filter.h \
    image_splitter.h \
    image_side_splitter.h \
    image_side_label.h \
    image_ctrl.h

FORMS += \
    sampler_window.ui \
    props_op_dft_filter.ui \
    image_side_label.ui \
    image_ctrl.ui

RESOURCES += \
    QtSampler.qrc

#
# for Qxt Library
#
win32 {
INCLUDEPATH += .
INCLUDEPATH += $$quote($(QXTDIR)\include\QxtCore)
INCLUDEPATH += $$quote($(QXTDIR)\include\QxtGui)
INCLUDEPATH += $$quote($(QXTDIR)\src\core)
INCLUDEPATH += $$quote($(QXTDIR)\src\gui)
LIBS += -L"C:\Qt\libqxt\lib"
}

win32 {
   CONFIG(debug, release|debug):LIBS += $$quote($(QXTDIR)\lib\QxtCored.lib)
   CONFIG(debug, release|debug):LIBS += $$quote($(QXTDIR)\lib\QxtGuid.lib)
   CONFIG(release, release|debug):LIBS += $$quote($(QXTDIR)\lib\QxtCore.lib)
   CONFIG(release, release|debug):LIBS += $$quote($(QXTDIR)\lib\QxtGui.lib)
}


#
# OpenGL
#
win32:INCLUDEPATH += $$quote($(NVSDKCOMPUTE_ROOT)/shared/inc)
unix:INCLUDEPATH += $$quote(/usr/local/NVIDIA_GPU_Computing_SDK/shared/inc)

#
# CUDA
#
# note:
# C:\ProgramData\NVIDIA Corporation\NVIDIA GPU Computing SDK 4.0
# should be replaced by $(NVSDKCOMPUTE_ROOT)
# but this is not recognized because of the proble in qmake
#
win32:INCLUDEPATH += $$quote($(NVSDKCOMPUTE_ROOT)/C/common/inc)
win32:INCLUDEPATH += $$quote($(CUDA_INC_PATH))
win32:LIBS += -L"C:\ProgramData\NVIDIA Corporation\NVIDIA GPU Computing SDK 4.0\C\common\lib\x64"

#
# for OpenCV
#
win32:INCLUDEPATH += $$quote($(OPENCVDIR)\include)

#
# Itf Common Library
#
win32:INCLUDEPATH += $$quote(C:/PixPLOT/PixImgLib)
win32:INCLUDEPATH += $$quote(C:/PixPLOT/PixQtLib)

win32 {
    CONFIG(debug, release|debug):LIBS += -L$$quote(../QtProjects/debug)
    CONFIG(release, release|debug):LIBS += -L$$quote(../QtProjects/release)
    LIBS += ItfQtLib.lib
}

OTHER_FILES +=





































































